

var app = angular.module("Uccelerate", ["checklist-model", "ngSanitize", "bc.Flickity"]);

function setCookie(cname, cvalue, exdays) {
    var d = new Date();
    d.setTime(d.getTime() + (exdays*24*60*60*1000));
    var expires = "expires="+ d.toUTCString();
    document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
}

function getCookie(cname) {
    var name = cname + "=";
    var decodedCookie = decodeURIComponent(document.cookie);
    var ca = decodedCookie.split(';');
    for(var i = 0; i <ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') {
            c = c.substring(1);
        }
        if (c.indexOf(name) == 0) {
            return c.substring(name.length, c.length);
        }
    }
    return "";
}


app.controller("master", function ($scope, $http, $timeout) {
  
  $scope.AngularLoaded = true;

  $scope.setCurrency = function(currency){
      $scope.PickedCurrency = currency;
      setCookie("currency", currency, 100);
      
      $timeout(function(){
        location.reload(true);
      }, 200)
      
  }

  $scope.getCart = function () {
    $http.post("/ucommerceapi/json/reply/GetBasket", {Culture: $scope.Culture}).then(function (response) {
      $scope.basket = response.data.Basket;
    });
  };

  $scope.addToCart = function (sku, variantsku) {
    $http.post("/ucommerceapi/json/reply/AddToBasket", { Sku: sku, VariantSku: variantsku, Quantity: 1 }).then(function (data) {
      $scope.getCart();
    });
  };

  $scope.removeLineItem = function (id) {
    $http.post("/ucommerceapi/json/reply/UpdateLineItem", { NewQuantity: 0, OrderLineId: id }).then(function (data) {
      $scope.getCart();
    });
  };

  $scope.updateLineItem = function (id, amount) {
    $http.post("/ucommerceapi/json/reply/UpdateLineItem", { NewQuantity: amount, OrderLineId: id }).then(function (data) {
      $scope.getCart();
    });
  };
    
  $timeout(function(){
      $scope.getCart();
  },200);
  

  $scope.searchQuery = "";

  $scope.$watch('searchQuery', function () {

    if ($scope.searchQuery.length > 0) {
      $http.post("/ucommerceapi/json/reply/search", { Keyword: $scope.searchQuery, CurrentPage: 0, Amount: 6 }).then(function (response) {
        $scope.searchResult = response.data.Products;

      });
    }
  });

});

app.controller("productCategory", function ($scope, $http, $timeout) {

  $scope.ClearFilter = function () {
    $scope.FilterCount = 0;
    $scope.filter = {
    };
  }


  /*Filter and sort*/
  $scope.filter = {
  };

  $scope.FilterCount = 0;
  $scope.SortSelect = "2";
  $scope.CurrentPage = 0;
  $scope.InitiatedPagination = false;
  $scope.FilteredProducts = [];
  $scope.ShowLoader = true;
  $scope.AllLoaded = false;


  $scope.changeFilter = function () {
    $scope.FilterCount = 0;
    $scope.ShowLoader = true;

    for (var prop in $scope.filter) {
      $scope.FilterCount += $scope.filter[prop].length;
    }

    $scope.CurrentPage = 0;

    $http.post("/ucommerceapi/json/reply/GetProducts", { BaseUrl: window.location.href, Filter: JSON.stringify($scope.filter), Amount: $scope.ProductsPerPage, CurrentPage: $scope.CurrentPage, CategoryList: $scope.pickedCategories, SortOrderId: parseInt($scope.SortSelect), Culture: $scope.Culture }).then(function (response) {
      $scope.FilteredProducts = response.data.Products;
      $scope.TotalResult = response.data.TotalResults;
      $scope.InitiatedPagination = true;
      $scope.ShowLoader = false;

      if (response.data.TotalResults == $scope.FilteredProducts.length)
        $scope.AllLoaded = true;
      else
        $scope.AllLoaded = false;


    });
  };

  $scope.loadProducts = function () {
    $http.post("/ucommerceapi/json/reply/GetProducts", { BaseUrl: window.location.href, Filter: JSON.stringify($scope.filter), Amount: $scope.ProductsPerPage, CurrentPage: $scope.CurrentPage, CategoryList: $scope.pickedCategories, SortOrderId: parseInt($scope.SortSelect), Culture: $scope.Culture }).then(function (response) {
      $scope.FilteredProducts = response.data.Products;
      $scope.ShowLoader = false;

      if (response.data.TotalResults == $scope.FilteredProducts.length)
        $scope.AllLoaded = true;

    });
  };

  $scope.changeSort = function () {
    $scope.ShowLoader = true;
    $scope.CurrentPage = 0;
    $http.post("/ucommerceapi/json/reply/GetProducts", { BaseUrl: window.location.href, Filter: JSON.stringify($scope.filter), Amount: $scope.ProductsPerPage, CurrentPage: $scope.CurrentPage, CategoryList: $scope.pickedCategories, SortOrderId: parseInt($scope.SortSelect), Culture: $scope.Culture }).then(function (response) {
      $scope.FilteredProducts = response.data.Products;
      $scope.ShowLoader = false;

      if (response.data.TotalResults == $scope.FilteredProducts.length)
        $scope.AllLoaded = true;
      else
        $scope.AllLoaded = false;

    });
  };

  $scope.loadMoreProducts = function () {
    $scope.ShowLoader = true;
    $scope.CurrentPage = $scope.CurrentPage + 1;

    $http.post("/ucommerceapi/json/reply/GetProducts", { BaseUrl: window.location.href, Filter: JSON.stringify($scope.filter), Amount: $scope.ProductsPerPage, CurrentPage: $scope.CurrentPage, CategoryList: $scope.pickedCategories, SortOrderId: parseInt($scope.SortSelect), Culture: $scope.Culture }).then(function (response) {
      $scope.ShowLoader = false;
      $scope.FilteredProducts = $scope.FilteredProducts.concat(response.data.Products);

      if (response.data.TotalResults == $scope.FilteredProducts.length)
        $scope.AllLoaded = true;
    });

  }
});

app.controller("product", function ($scope, $http, $sce, $timeout) {
  $scope.Review = {};
  $scope.ShowMessage = false;
  $scope.SubmitReview = function () {

    console.log($scope.Review)
    $http.post("/ucommerceapi/json/reply/ProductReview", { Title: $scope.Review.Title, Comments: $scope.Review.Comments, Name: $scope.Review.Name, Email: $scope.Review.Email, Rating: $scope.Review.Rating, Sku: $scope.Review.Sku }).then(function (response) {
      $scope.ShowMessage = true;
    });
  }
});


app.controller("checkout", function ($scope, $http, $sce, $timeout) {

  function getCheckoutMarkup() {
      console.log($scope.CheckoutForm.paymentSelectionLabel.toLowerCase())
    if ($scope.CheckoutForm.paymentSelectionLabel.toLowerCase() == "klarna") {
      $http.post("/ucommerceapi/json/reply/GetKlarnaMarkup", { CountryId: parseInt($scope.CheckoutForm.CountryId) }).then(function (response) {
        console.log("klarna updated")
        $scope.checkoutMarkup = $sce.trustAsHtml("");

        if ($scope.int == 0) {
          $scope.int = 1;
          $scope.checkoutMarkup = $sce.trustAsHtml(response.data.Markup);
        } else {
          //didnt update correctly without this
          $timeout(function () {
            $scope.checkoutMarkup = $sce.trustAsHtml(response.data.Markup);
          }, 200);
        }

      });
    }
  }

  $scope.getCart = function () {
    $http.post("/ucommerceapi/json/reply/GetBasket", {Culture: $scope.Culture}).then(function (response) {
      $scope.basket = response.data.Basket;
      $scope.discounts = response.data.Basket.Discounts;
    });
  };

  $scope.addToCart = function (sku, variantsku) {
    $http.post("/ucommerceapi/json/reply/AddToBasket", { Sku: sku, VaraintSku: variantsku, Quantity: 1 }).then(function (data) {
      $scope.getCart();
      getCheckoutMarkup();
    });
  };

  $scope.removeLineItem = function (id) {
    $http.post("/ucommerceapi/json/reply/UpdateLineItem", { NewQuantity: 0, OrderLineId: id }).then(function (data) {
      $scope.getCart();
      getCheckoutMarkup();
    });
  };

  $scope.updateLineItem = function (id, amount) {
    $http.post("/ucommerceapi/json/reply/UpdateLineItem", { NewQuantity: amount, OrderLineId: id }).then(function (data) {
      $scope.getCart();
      getCheckoutMarkup();
    });
  };

  $timeout(function(){
      $scope.getCart();
  },200);
  

  $scope.CheckoutForm = {};
  $scope.CheckoutForm.CountryId = "";
  $scope.CheckoutForm.paymentSelectionLabel = "";

  $scope.getShippingAndPaymentMethods = function (UpdatePayment) {

    if (typeof $scope.CheckoutForm.CountryId != "undefined"){
    
        $http.post("/ucommerceapi/json/reply/GetShippingAndPaymentMethods", { CountryId: parseInt($scope.CheckoutForm.CountryId) }).then(function (response) {
    
          $scope.shippingMethods = response.data.ShippingMethods;
          $scope.CheckoutForm.shippingSelection = String($scope.shippingMethods[0].Id);
        
          $scope.paymentMethods = response.data.PaymentMethods;
          console.log('update: '+UpdatePayment)
          if(UpdatePayment){
              $scope.CheckoutForm.paymentSelection = String($scope.paymentMethods[0].Id);
              $scope.CheckoutForm.paymentSelectionLabel = String($scope.paymentMethods[0].Name);
          }         
            getCheckoutMarkup();
    
        });
    }
  };

  $timeout(function(){
      $scope.getShippingAndPaymentMethods(true);
  },200);
  

  function updateCheckout(UpdatePayment) {


    $http.post("/ucommerceapi/json/reply/SetPaymentAndShipping", { ShipmentId: parseInt($scope.CheckoutForm.shippingSelection), PaymentId: parseInt($scope.CheckoutForm.paymentSelection), CountryId: parseInt($scope.CheckoutForm.CountryId) }).then(function (response) {
      $scope.getCart();
      $scope.discounts = response.data.Discounts;
      
      $scope.getShippingAndPaymentMethods(UpdatePayment);
     
      
    });
  }

  $scope.$watch('CheckoutForm.shippingSelection', function () {
      
    if (typeof $scope.CheckoutForm.paymentSelection != "undefined" && typeof $scope.CheckoutForm.shippingSelection != "undefined" && typeof $scope.CheckoutForm.CountryId != "undefined") {
      
      updateCheckout(true);

    }
  });

  
  $scope.SetPaymentMethod = function (method) {
      
      $scope.CheckoutForm.paymentSelection = method.Id;
      $scope.CheckoutForm.paymentSelectionLabel = method.Name;
      
    if (typeof $scope.CheckoutForm.paymentSelection != "undefined" && typeof $scope.CheckoutForm.shippingSelection != "undefined" && typeof $scope.CheckoutForm.CountryId != "undefined") {
      updateCheckout(false);    
      
    }
  };

  $scope.$watch('CheckoutForm.CountryId', function () {

    if (typeof $scope.CheckoutForm.paymentSelection != "undefined" && typeof $scope.CheckoutForm.shippingSelection != "undefined" && typeof $scope.CheckoutForm.CountryId != "undefined") {
      updateCheckout(true);

    }
  });


  $scope.setVoucher = function () {
    $http.post("/ucommerceapi/json/reply/SetVoucher", { VoucherCode: $scope.VoucherCodeInput }).then(function (response) {
      $scope.getCart();
      updateCheckout(false);
    });
  };

  $scope.placeOrder = function () {
    $http.post("/ucommerceapi/json/reply/PlaceOrder", $scope.CheckoutForm).then(function (response) {
      window.location.href = "/checkout?payment=1"
    });
  }

});

app.controller("search", function ($scope, $http) {
    
  $scope.SearchLoading = false;
  $scope.ClearFilter = function () {
    $scope.FilterCount = 0;
    $scope.filter = {
    };
  }


  /*Filter and sort*/
  $scope.filter = {
  };

  $scope.FilterCount = 0;
  $scope.SortSelect = "2";
  $scope.CurrentPage = 0;
  $scope.InitiatedPagination = false;
  $scope.FilteredProducts = [];
  $scope.ShowLoader = true;
  $scope.AllLoaded = false;


  $scope.postSearch = function () {
    $scope.SearchLoading = true;
    $http.post("/ucommerceapi/json/reply/search", { Keyword: $scope.mainSearch, Start: 0, Amount: 0 }).then(function (response) {
      $scope.FilteredProducts = response.data.Products;
      $scope.totalResult = response.data.TotalResult;
      $scope.wordSearched = $scope.mainSearch;
      $scope.SearchLoading = false;

      $scope.currentPage = 1;
      $scope.pages = [];
      if ($scope.totalResult > 0) {
        var pageAmount = 10;
        var pagesAmount = Math.ceil($scope.totalResult / pageAmount, 1);

        for (var i = 0; i < pagesAmount; i++) {
          $scope.pages.push({ PageName: (i + 1) });
        }
      }
    });
  };

  $scope.setPage = function (page) {
    var pageAmount = 10;
    var start = (page - 1) * pageAmount;

    $http.post("/ucommerceapi/json/reply/search", { Keyword: $scope.mainSearch, Start: 0, Amount: 0 }).then(function (response) {
      $scope.FilteredProducts = response.data.Products;
      $scope.totalResult = response.data.TotalResult;
      $scope.wordSearched = $scope.mainSearch;
    });
  }


  $scope.postSearch();


});